﻿using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace WowToggler
{
    public partial class Form1 : Form
    {
        private IntPtr handleId;
        private bool isHidden;
        const int SW_HIDE = 0;
        const int SW_SHOW = 5;
        
        public Form1()
        {
            handleId = FindWindow(null, "World of Warcraft");
            InitializeComponent();
        }

        
        
        private void button1_Click(object sender, EventArgs e)
        {
            ToggleWindow();
        }
        
        private void ToggleWindow()
        {
            if (!isHidden)
            {
                ShowWindow(handleId, SW_HIDE);
                isHidden = true;
                btnToggle.Text = "Show";
            }
            else
            {
                ShowWindow(handleId, SW_SHOW);
                isHidden = false;
                btnToggle.Text = "Hide";
            }
                
        }

        public void Form1_Resize(object sender, EventArgs e)
        {
            if (FormWindowState.Minimized == this.WindowState)
            {
                notifyIcon1.Visible = true;                
                this.Hide();
            }
            else if (FormWindowState.Normal == this.WindowState)
            {
                notifyIcon1.Visible = false;
            }
        }

        [DllImport("user32.dll")]
        public static extern IntPtr FindWindow(String sClassName, String sAppName);

        [DllImport("user32.dll")]
        public static extern Boolean ShowWindow(IntPtr hWnd, Int32 nCmdShow);

        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            this.Show();
            this.Focus();
        }
    }
}
